#pragma once
class HeightField
{
public:
	HeightField(int x, int y, int z);
	~HeightField(void);

	bool loadTextures();

	void splashAtPoint(int x, int y, float height);
	void splashCenter(float height);

	void setTimeStep(float lessThanOne);

	void update();
	void drawGround();
	void draw();
	void drawSimple();
	
private:
	int time;
	float waveSpeedSquared;
	float timeStep;
	float velocityDrag;

	float** heightField;
	float** velocityField;
	float** forceField;

	int columnsX;
	int columnsY;
	float initialHeight;

	SDL_Surface* textureSurface;
	GLuint textureHandle;
};

