// OpenGLTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

//#define SCREEN_WIDTH 768
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
#define SCREEN_BPP 32

int waterHeight = 16;

HeightField water(84,84,waterHeight);
//HeightField water(64,64,10); // 64, 64, 10

double clickedX (0);
double clickedY (0);
double clickedZ (0);
double rayX (0);
double rayY (0);
double rayZ (0);
Vector3f projRay;
double intersectionX(0), intersectionY(0), intersectionZ(0);

GLuint pixelDataHandle;
char *pixelData[128 * 128 * 3];

int running = 1;

void drawAxes(float x, float y, float z) {
	glPushMatrix();
	glTranslatef(-x, -y, -z);
	glBegin(GL_LINES);
	glColor3f(1.0f, 0.0f, 0.0f);
	glVertex3f(0.0f, 0.0f, 0.0f);
	glVertex3f(1.0f, 0.0f, 0.0f);

	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(0.0f, 0.0f, 0.0f);
	glVertex3f(0.0f, 1.0f, 0.0f);

	glColor3f(0.0f, 0.0f, 1.0f);
	glVertex3f(0.0f, 0.0f, -0.5f);
	glVertex3f(0.0f, 0.0f, 2.0f);
	glEnd();
	glPopMatrix();
}

void drawClicked() {
		drawAxes(clickedX, clickedY, clickedZ);
				
		glBegin(GL_LINES);
		glColor3f(1.0f, 1.0f, 1.0f);
		glVertex3f(0, 0, 0);
		glVertex3f(clickedX, clickedY, clickedZ);
		//glVertex3f(0, 0, 0);
		//glVertex3f(projRay.x, projRay.y, projRay.z);
		glEnd();

}

void drawIntersection() {
	drawAxes(intersectionX, intersectionY, intersectionZ);

	glBegin(GL_LINES);
	glColor3f(0.3f, 0.3f, 0.6f);
	glVertex3f(0.0f, 0.0f, 0.0f);
	glVertex3f(intersectionX, intersectionY, intersectionZ);
	glEnd();
}

void draw() {
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glEnable(GL_DEPTH_TEST);

	//drawClicked();
	//drawIntersection();
	
	
	//float lightPosition[] = { 50.0f, 50.0f, 100.0f };
	float lightPosition[] = { 00.0f, 00.0f, 70.0f }; //100
	float specular[] = { 0.4f, 0.4f, 0.4f };
	float ambience[] = { 0.5f, 0.5f, 0.6f };

	glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambience);
	//glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0002f);
	glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.0001f);

	glPushMatrix();
		//glTranslatef(40.0f, 40.0f, 0.0f);
		glTranslatef(40.0f, 40.0f, 0.0f);
		glLightfv(GL_LIGHT0, GL_POSITION, lightPosition);
	glPopMatrix();

	drawAxes(0.0f, 0.0f, 0.0f);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	glShadeModel(GL_SMOOTH);
	//glShadeModel(GL_FLAT);

	glColorMaterial ( GL_FRONT_AND_BACK, GL_DIFFUSE ) ; // GL_EMISSION vs GL_AMBIENT_AND_DIFFUSE
    glEnable ( GL_COLOR_MATERIAL ) ;
			
	water.drawGround();

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE);

	water.update();
	water.draw();

	glDisable(GL_BLEND);
	// US develop its brand to the world and then attack
	// US fabricating facts to influence the public
	// A loyalty that is based off of created ignorance
	// In Google, the architecture and benefits create this ignorance bubble
	// So people can free themselves to think about other things
	//

	glDisable( GL_COLOR_MATERIAL );

	glEnable(GL_TEXTURE_2D);
	//glBindTexture(GL_TEXTURE_2D, pixelDataHandle);
	
	//glViewport(0, 0, 128, 128);
	//glReadPixels(0, 0, 128, 128, GL_RGB, GL_UNSIGNED_BYTE, pixelData);
	//glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 128, 128, GL_RGB, GL_UNSIGNED_BYTE, pixelData);
	//glViewport(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

	//glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    //glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	//glBegin(GL_QUADS);
	
	//glTexCoord2f(0.0f, 0.0f);
	//glNormal3f(0.0f, 1.0f, 0.0f);
	//glVertex3f(0.0f, 0.0f, 18.0f);

	//glTexCoord2f(0.9f, 0.0f);
	//glNormal3f(0.0f, 1.0f, 0.0f);
	//glVertex3f(100.0f, 0.0f, 18.0f);

	//glTexCoord2f(0.9f, 0.9f);
	//glNormal3f(0.0f, 1.0f, 0.0f);
	//glVertex3f(100.0f, 100.0f, 18.0f);

	//glTexCoord2f(0.0f, 0.9f);
	//glNormal3f(0.0f, 1.0f, 0.0f);
	//glVertex3f(0.0f, 100.0f, 18.0f);

	//glEnd();

	glDisable(GL_TEXTURE_2D);

	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHTING);
}

void initExtensions() {
	//GLuint glCreateProgram = ( (PFNGLCREATEPROGRAMPROC) wglGetProcAddress("glCreateProgram") ) ();
	//GLuint glCreateShader = ( (PFNGLCREATESHADERPROC) wglGetProcAddress("glCreateShader") ) ( GL_VERTEX_SHADER );
}

bool init_GL() {
	
	initExtensions();

	glClearColor(0.0, 0.0, 0.0, 1.0);

	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	//glOrtho( 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, -1, 1 );
	gluPerspective( 60.0, (double)SCREEN_WIDTH / (double)SCREEN_HEIGHT, 1, 100000 );
	
	glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();

	glRotatef( -60.0f, 1.0f, 0.0f, 0.0f);
	glTranslatef(-10.0f, 10.0f, -15.0f);
	glRotatef( -20.0f, 0.0f, 0.0f, 1.0f);
	glTranslatef(-4.0f, 4.0f, 0.0f);

	// Scale .2 .2 .2
	glScalef(0.19f, 0.19f, 0.19f);

	if ( glGetError() != GL_NO_ERROR ) {
		return false;
	}

	water.loadTextures();
	water.setTimeStep(0.03);
	//water.splashAtPoint(5, 5, .00001);
	water.splashCenter(-3.5);
	//water.splashAtPoint(25, 25, 2);
	//water.splashAtPoint(50, 25, .0002);
	//water.splashAtPoint(50, 55, .0001);

	glLightModeli (GL_LIGHT_MODEL_COLOR_CONTROL,GL_SEPARATE_SPECULAR_COLOR);


	glViewport(0, 0, 128, 128);
	draw();
	glReadPixels(0, 0, 128, 128, GL_RGB, GL_UNSIGNED_BYTE, pixelData);
	
	glGenTextures(1, &pixelDataHandle);
	glBindTexture(GL_TEXTURE_2D, pixelDataHandle);
	
	glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
    glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	
	glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 128, 128, GL_RGB, GL_UNSIGNED_BYTE, pixelData);

	glViewport(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);

	return true;
}


int main(int argc, char* argv[])
{
	if ( SDL_Init( SDL_INIT_EVERYTHING ) < 0 ) {
		return -1;
	}

	if ( SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_OPENGL ) == NULL ) { 
		return false;
	}

	if ( init_GL() == false ) {
		return false;
	}

	glewInit();
	if ( glewInit() != GLEW_OK ) {
		return false;
	}

	if ( GLEW_ARB_vertex_shader && GLEW_ARB_fragment_shader ) {
		printf("Ready for GLSL\n");
	} else {
		printf("Not totally ready :\\ \n");
		exit(1);
	}

	char *vs, *fs;
	
	GLuint vertexShader = glCreateShaderObjectARB( GL_VERTEX_SHADER_ARB );
	//glShaderSourceARB( vertexShader, 1, 
	GLuint program = glCreateProgramObjectARB();
	glAttachObjectARB(program, vertexShader);
	glLinkProgram(program);
	


	SDL_WM_SetCaption( "OpenGL Test", NULL );

	SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 );
    SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 32 );
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

	SDL_Event event;

	double t(0); 
	double modelViewMatrix[16];
	double projectionMatrix[16];
	int viewPort[4];

	while ( running ) { 
		while ( SDL_PollEvent(&event) ) {	
			switch (event.type) {
            case SDL_MOUSEBUTTONDOWN:
				std::cout << "Mouse button " << event.button.button << " pressed at " << event.button.x << "," <<  event.button.y << std::endl;

				glGetDoublev(GL_MODELVIEW_MATRIX, modelViewMatrix);
				glGetDoublev(GL_PROJECTION_MATRIX, projectionMatrix);
				glGetIntegerv(GL_VIEWPORT, viewPort);
				
				gluUnProject(event.button.x, viewPort[3] - event.button.y, 0, modelViewMatrix, projectionMatrix, viewPort, &clickedX, &clickedY, &clickedZ);
				//std::cout << "point: " << clickedX << "," << clickedY << "," << clickedZ << std::endl;
				gluUnProject(event.button.x, viewPort[3] - event.button.y, 1, modelViewMatrix, projectionMatrix, viewPort, &rayX, &rayY, &rayZ);
		
				projRay.x = rayX - clickedX;
				projRay.y = rayY - clickedY;
				projRay.z = rayZ - clickedZ;

				t = waterHeight - clickedZ;
				
				if ( rayZ - clickedZ != 0 ) {
					t = t / ( ( rayZ - clickedZ ) );
					
					intersectionX = projRay.x * t + clickedX;
					intersectionY = projRay.y * t + clickedY;
					intersectionZ = projRay.z * t + clickedZ;
					if ( (rand() % 10) >= 6 ) { 
						water.splashAtPoint( (int) intersectionX, (int) intersectionY, rand() % 9);
						//std::cout << "SMALL splash" << std::endl;
					} else {
						//std::cout << "big splash" << std::endl;
						water.splashAtPoint( (int) intersectionX, (int) intersectionY, rand() % waterHeight);
					}
				}

                break;
			case SDL_KEYDOWN:
					
				break;
			case SDL_KEYUP:
				break;
			case SDL_QUIT:
				running = 0;
				break;
			}
		}

		draw();
		SDL_GL_SwapBuffers();
	}

	SDL_Quit();

	return 0;
}

