#include "StdAfx.h"
#include "Vector3f.h"


Vector3f::Vector3f(void)
{
	x = 0, y = 0, z = 0;
}


Vector3f::~Vector3f(void)
{
}

Vector3f Vector3f::operator*(Vector3f rhs) {
	Vector3f ret;
	ret.x = y * rhs.z - z * rhs.y;
	ret.y = rhs.x * z - x * rhs.z;
	ret.z = x * rhs.y - y * rhs.x;
	return ret;
}

Vector3f Vector3f::normalized() {
	Vector3f ret;
	float length = x * x + y * y + z * z;
	length = sqrt(length);
	if (length == 0) {
		return *this;
	}
	ret.x = x / length;
	ret.y = y / length;
	ret.z = z / length;
	return ret;
}

Vector3f Vector3f::inverted() {
	Vector3f ret;
	ret.x = -this->x;
	ret.y = -y;
	ret.z = -z;
	return ret;
}